一起分析Java中异常的产生原因及处理

一起分析Java中异常的产生原因及处理,第1张

一起分析Java中异常的产生原因及处理 本篇文章给大家带来了关于java的相关知识,其中主要介绍了关于异常的相关问题,异常又称为例外,是一个在程序执行期间发生的事件,它中断正在执行程序的正常指令流,下面一起来看一下,希望对大家有帮助。

推荐学习:《java视频教程》

Java中的异常(Exception)又称为例外,是一个在程序执行期间发生的事件,它中断正在执行程序的正常指令流。为了能够及时有效地处理程序中的运行错误,必须使用异常类。

1. 异常产生的原因和分类1.1 异常产生的原因

在Java中异常产生,主要是有三种原因:

(1)编写程序代码中的错误产生的异常,比如数组越界、空指针异常等,这种异常叫做未检查的异常,一般需要在类中处理这些异常

(2)Java内部错误发生的异常,Java虚拟机产生异常

(3)通过throw(抛出异常)语句手动生成的异常,这种异常叫做检查的异常,一般是用来给方法调用者一些必要的信息

1.2 异常分类

(1)Throwable:是异常体系的顶层类,其派生出两个重要的子类, Error 和 Exception

而 Error 和 Exception 两子类分别表示错误和异常。

区别就是不检查异常(Unchecked Exception)和检查异常(Checked Exception)

(2)Exception 类用于用户程序可能出现的异常情况,它也是用来创建自定义异常类型类的类。

(3)Error 定义了在通常环境下不希望被程序捕获的异常。Error 类型的异常用于 Java 运行时由系统显示与运行时系统本身有关的错误。堆栈溢出是这种错误的一例。

异常可能在编译时发生,也有可能在程序运行时发生,根据发生时机不同,可以分为:

运行时异常都是 RuntimeException 类及其子类异常,如 NullPointerException、IndexOutOfBoundsException 等,这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理。这些异常一般由程序逻辑错误引起,程序应该从逻辑角度尽可能避免这类异常的发生。

比如:

编译时异常是指 RuntimeException 以外的异常,类型上都属于 Exception 类及其子类。从程序语法角度讲是必须进行处理的异常,如果不处理,程序就不能编译通过。如 IOException、ClassNotFoundException 等以及用户自定义的 Exception 异常,一般情况下不自定义检查异常。

比如

class Person implements Cloneable{
    @Override
    protected Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
public class Test01 {

    public static void main(String[] args) {
        Person person =new Person();
        Person person1 =(Person) person.clone();
    }
}


2. 异常的处理2.1 防御式编程

错误在代码中是客观存在的. 所以要让程序出现问题的时候快速通知程序猿.

通知有两种方式:

(1)LBYL 在操作之前就做充分的检查

private static int pide() {
        int a = 0, b = 0;
        Scanner scanner = new Scanner(System.in);
        a = scanner.nextInt();
        b = scanner.nextInt();
        if (b == 0) {
            System.out.println("除数为0");
            return 0;
        } else {
            return a / b;
        }
    }

缺点:正常流程和错误处理流程代码混在一起, 代码整体条理不清晰。

(2)EAFP 先操作遇到问题再处理

private static int pide() {
        int a = 0, b = 0;
        try (Scanner scanner = new Scanner(System.in)) {
            a = scanner.nextInt();
            b = scanner.nextInt();
            return a / b;
        } catch (ArithmeticException exception) {
            System.out.println("除数为0");
            return 0;
        } 
    }

优点:正常流程和错误流程是分离开的, 程序员更关注正常流程,代码更清晰,容易理解代码

处理异常的核心思想就是EAFP

2.2 异常的抛出(throw)

在编写程序时,如果程序中出现错误,这就需要将错误的信息通知给调用者

这里就可以借助关键字throw,抛出一个指定的异常对象,将错误信息告知给调用者。

比如写一个运行时异常

    public static void func2(int a) {
        if(a == 0) {
           //抛出的是一个指定的异常,最多的使用方式是,抛出一个自定义的异常
            throw new RuntimeException("a==0");
        }
    }
    public static void main(String[] args) {
        func2(0);
    }

注意:

(1)throw必须写在方法体内部

(2)如果抛出的是编译时异常,用户就必须要处理,否则无法通过编译

(3)如果抛出的运行时异常,则可以不用处理,直接交给JVM来处理

(4)一旦出现异常,后面的代码就不会执行

2.3 异常的捕获2.3.1 throws异常声明

throws处在方法声明时参数列表之后,当方法中抛出编译时异常,用户不想处理该异常,

此时就可以借助throws将异常抛 给方法的调用者来处理。

格式:

修饰符 返回值类型 方法名(参数列表) throws 异常类型 {

}

如果说方法内部抛出了多个异常,throws之后就必须跟多个异常类型,用逗号进行分隔

    public static void func2(int a) throws CloneNotSupportedException, FileNotFoundException {
        if(a == 0) {
            throw new CloneNotSupportedException("a==0");
        }
        if(a == 1) {
            throw new FileNotFoundException();
        }
    }

如果抛出多个异常类型有父子关系,直接声明父类

    public static void func2(int a) throws Exception {
        if(a == 0) {
            throw new CloneNotSupportedException("a==0");
        }
        if(a == 1) {
            throw new FileNotFoundException();
        }
    }

调用声明抛出异常的方法时,调用者必须对该异常进行处理,或者继续使用throws抛出

   public static void main(String[] args) throws FileNotFoundException, CloneNotSupportedException {
        func2(0);
    }
2.3.2 try-catch捕获异常并处理

当程序抛出异常的时候,程序员通过try-each处理了异常

    public static void main(String[] args) {
        try {
            int[] array = null;
            System.out.println(array.length);
        }catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        }
        System.out.println("其他程序!");
    }

如果程序抛出异常,不处理异常,那就会交给JVM处理,JVM处理就会把程序立即终止

并且,即使用了try-each 也必须捕获一个对应的异常,如果不是对应异常,也会让JVM进行处理

如果try抛出多个异常,就必须用多个catch进行捕获

这里注意,用多个catch进行捕获,不是同时进行捕获的,因为不可能同时抛不同的异常

    public static void main(String[] args) {
        try {
            int[] array = null;
            System.out.println(array.length);
        }catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        }catch (ArithmeticException e) {
            System.out.println("捕获到了一个算术异常!");
        }
        System.out.println("其它代码逻辑!");
    }

也可以简写一下

    public static void main(String[] args) {
        try {
            int[] array = null;
            System.out.println(array.length);
        }catch (NullPointerException  | ArithmeticException e) {
            System.out.println("捕获到了一个空指针或算术异常!");
        }
        System.out.println("其它代码逻辑!");
    }

如果异常之间具有父子关系,那就必须子类异常在前,父类异常在后catch,不然会报错

    public static void main(String[] args) {
        try {
            int[] array = null;
            System.out.println(array.length);
        }catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        }catch (Exception) {
            System.out.println("捕获到了一个算术异常!");
        }
        System.out.println("其它代码逻辑!");
    }

2.3.3 finally

finally用来进行资源回收,不论程序正常运行还是退出,都需要回收资源

并且异常会引发程序的跳转,可能会导致有些语句执行不到

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        try {
            int[] array = null;
            System.out.println(array.length);
        }catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        }catch (ArithmeticException e) {
            System.out.println("捕获到了一个算术异常!");
        }finally {
            scanner.close();
            System.out.println("进行资源关闭!");
        }
        System.out.println("其它代码逻辑!");
    }

如果不为空,那么finally还会被执行吗

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        try {
            int[] array = {1,2,3};
            System.out.println(array.length);
        }catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        }catch (ArithmeticException e) {
            System.out.println("捕获到了一个算术异常!");
        }finally {
            scanner.close();
            System.out.println("进行资源关闭!");
        }
        System.out.println("其它代码逻辑!");
    }

所以,不管程序会不会抛出异常,finally都会执行

如果将资源写在try中会自动帮助,关掉资源的

    public static void main(String[] args) {
        try (Scanner scanner = new Scanner(System.in)) {
            int[] array = {1, 2, 3};
            System.out.println(array.length);
        } catch (NullPointerException e) {
            System.out.println("捕获到了一个空指针异常!");
        } catch (ArithmeticException e) {
            System.out.println("捕获到了一个算术异常!");
        } finally {
            System.out.println("进行资源关闭!");
        }
        System.out.println("其它代码逻辑!");
    }

下面看这一段代码

    public static int func(int a) {
        try{
            if(a == 0) {
                throw  new ArithmeticException();
            }
            return a;
        } catch (ArithmeticException e) {
            System.out.println("算术异常!");
        } finally {
            return 20;
        }
    }

    public static void main(String[] args) {
        System.out.println(func(10));
    }

可以发现即使有return,finally也会被执行

总结一下:

throw抛出异常,throws声明异常

finally语句一定会执行

3.自定义异常类

虽然java中有很多异常类,但是在实际开发中所遇到的一些异常,不能完全表示,

所以这就需要我们自定义异常类

举一个例子

先自定义一个运行时异常

//自定义了一个运行时异常
public class MyException extends RuntimeException{
    public MyException() {

    }
    public MyException(String message) {
        super(message);
    }
}

写一个类来捕获这个自定义异常

public class Test04 {
    public static void func(int a ) {
        throw new MyException("呵呵!");
    }

    public static void main(String[] args) {
        try {
            func(20);
        }catch (MyException myException) {
            myException.printStackTrace();
        }finally {
            System.out.println("sadasdasd");
        }

    }
}

下面写一个用户登录的自定义异常类

class UserNameException extends RuntimeException {
    public UserNameException() {

    }
    public UserNameException(String message) {
        super(message);
    }
}
class PasswordException extends RuntimeException {

    public PasswordException() {
    }

    public PasswordException(String message) {
        super(message);
    }
}
public class LogIn {
    private static String uName = "admin";
    private static String pword = "1111";

    public static void loginInfo(String userName, String password) {
        if ( !uName.equals(userName)) {
            throw new UserNameException("用户名错误!");
        }
        if ( !pword.equals(password)) {
            throw new RuntimeException("密码错误!");

        }
        System.out.println("登录成功!");
    }

    public static void main(String[] args) {
        try {
            loginInfo("admin","1111");
        } catch (UserNameException e) {
            e.printStackTrace();
        } catch (PasswordException e) {
            e.printStackTrace();
        }
    }
}

注意:

自定义异常默认会继承 Exception 或者 RuntimeException

继承于 Exception 的异常默认是受查异常

继承于 RuntimeException 的异常默认是非受查异常

推荐学习:《java视频教程》

以上就是一起分析Java中异常的产生原因及处理的详细内容,

欢迎分享,转载请注明来源:内存溢出

原文地址:https://outofmemory.cn/langs/1372006.html

(0)
打赏 微信扫一扫微信扫一扫 支付宝扫一扫支付宝扫一扫
上一篇 2022-06-16
下一篇2022-06-16

随机推荐

  • 中职专业课教师资格证科目一知识点总结

    第二章 教育法律责任在实际工作中并非所有的教育法律关系主体都能依法履行责任,这就需要对违法责任人进行处理,强制其承担相应的法律责任,同时,对受到侵害的相对人,应实施补救,即实施法律救济,依法追究违法主

    2022-12-10
    000
  • 中老年人应该怎样学二胡?

    众所周知,我国已经逐步进入老龄化的社会,老年人的生活水平已经引起了全社会的广泛关注,尤其是他们的精神生活和文化娱乐等活动,更是关注的热点。为此,全国各地都相继开办了一些老年大学、老干部活动中心、老年艺

    2022-12-10
    000
  • 弹古筝必背的指法口诀是什么?

    古筝是我国独特、重要的传统民族乐器之一。它以音色优美,音域宽广、演奏技巧丰富,具有相当的表现力,因此深受广大人民群众的喜爱。今天小编给大家整理了初学古筝的指法口诀,希望对大家有所帮助。对于一些刚接触古

    2022-12-10
    000
  • 如何朗诵声音好听

    朗读语言要求要准确、鲜明、生动,富于表现力和感染力。我们不能象平时说话那样,在朗读的时候要根据文章内容的不同,用不同的声音色彩来处理。为了使受众都能听到、听清,朗读者往往都会加大音量(除非借助话筒音响

  • 立绘和原画有区别吗?接单价格是多少?

    立绘和原画有区别吗?特别是刚接触到板绘的小伙伴, 一提到立绘和原画,很多小伙伴就蒙了,不是一种吗?当然不是啦! 今天就来讲一讲原画和立绘的区别。什么是立绘指ACG角色站立姿态的绘画,背景为透明的角色画

    2022-12-10
    000
  • 警衔级别

    人民警察警衔共设五等十三级:总警监、副总警监;警监(一级、二级、三级);警督(一级、二级、三级);警司(一级、二级、三级);警员(一级、二级)。担任行政职务的人民警察,实行下列职务等级编制警衔: 人民

    2022-12-10
    000
  • 2021年辽宁驾驶员培训考试题考驾照科目四试题(261)

    *1.驾驶机动车驶离高速公路要经过减速车道减速后进入匝道。A.正确B.错误【参考答案】A【参考解析】高速公路出口的匝道一般限速每小时60公里以下,弯道限速每小时40公里以下。而在高速公路上行驶时的车速

    2022-12-10
    000
  • 猪男猴女婚姻状况

    你们俩不太速配,在一起需要面对较多的考验。她的自信心强,聪颖机智,喜欢挑战,不喜欢受到束缚,异性缘佳;而你性情温和,待人热情诚恳,让人看了就想要亲近。你们多会因为好奇心而走近对方,但真正相处,原来的新

    2022-12-10
    000
  • 猕猴桃和奇异果的区别?

    猕猴桃和奇异果没有区别,它们是同一种水果。奇异果就是kiwifruit的音译,是猕猴桃在新西兰的名字。有些商家用奇异果的名字卖猕猴桃有两种原因,一种是进口水果,另一个是为了抬高价格,其实和猕猴桃就是同

    2022-12-10
    000

发表评论

登录后才能评论

评论列表(0条)

    保存